/* 
   Nombre: Placas.dev         DEV-C++ 4.0
   Autor: Carlos Fernando Valarezo Loaiza
   Fecha: 2002 - 02 - 20
   Descripcin: Programa para demostrar el uso de archivos en DEV - C++
                con sus respectivas cajas de dilogo de Abrir y Guardar Como
                Su utilidad es para registrar las multas de diferentes placa de
                carros, adjunto al programa consta un manual, para manejarlo
                adecuadamente, dejo a su disposicin Placas y Multas, quedan
                libres de modificarlo y cambiarlo a voluntad, siempre con fines
                didcticos y no lucrativos.
                Si se da algn problema, comentarios, preguntas, etc.
                con Placas y Multas o algo sobre C++ entorno windows consltame a
                cfervl@yahoo.com
   Copyright: CFVL
*/
#include <windows.h> /*librera para entorno windows*/
#include <cstdlib> /*librera para atoi*/
#include <cstring> /*librera para strcmp y strcpy*/
#include "Placa.h" /*archivo definido por el programador*/
#include "recursos.h"/*archivo definido por el programador*/
/*Prototipo del Procedimiento de windows*/
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);
/*Todas las funciones que devuelven un tipo
  BOOL CALLBACK [NombreFuncin](Parmetros);
  son para menejar las diferentes cajas de dilogo
  de cualquier programa
*/
BOOL CALLBACK Crear(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK Revisar(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK Multar(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK Placa(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK Acerca(HWND, UINT, WPARAM, LPARAM);
BOOL AbrirArchivo(HWND, LPSTR);
BOOL GuardarArchivo(HWND, LPSTR);
BOOL GuardarArchivoRevisar(HWND, LPSTR);
BOOL AbrirGuardar(HWND, BOOL);
BOOL AbrirGuardarRevisar(HWND, BOOL);
BOOL pagar;
PLACA otraplaca;
PLACA nuevo[50];
PLACA aux[50];
char cnt[6];
char szClassName[ ] = "Placas";
char szNombreVentana[ ] = "Placas y Multas";
char boton[ ] = "button";
char label[ ] = "static";
char placa_archivo[8];
char placa_teclado[8];
int cont = 0, multas = 0, suma = 0;
int i = 0;
int j = 0;
int m = 0;
/*Declaracin de los manipuladores de los controles del men principal*/
HWND hBtCrear, hBtRevisar, hBtCerrar, hStDialogo;
HWND nBtAcerca, frInforma;
HINSTANCE hInst;
int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil)

{
    HWND hwnd;
    MSG messages;
    WNDCLASSEX wincl;


    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;
    wincl.style = CS_DBLCLKS;
    wincl.cbSize = sizeof(WNDCLASSEX);

    /*Si deseas cambiar el cono por defecto esta es la manera de hacerlo,
      al igual con el cursor*/
    wincl.hIcon = LoadIcon(hThisInstance, MAKEINTRESOURCE(MICONO));
    wincl.hIconSm = LoadIcon(hThisInstance, MAKEINTRESOURCE(MICONO));
    wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;
    wincl.cbWndExtra = 0;
    wincl.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);
    hInst = hThisInstance;
    if(!RegisterClassEx(&wincl)) return 0;
    hwnd = CreateWindowEx(
           0,
           szClassName,
           szNombreVentana,
           /*Estilos de la ventana para evitar el maximizado o cambio de
             tamao de la ventana*/
           WS_SYSMENU|WS_MINIMIZEBOX,
           CW_USEDEFAULT,
           CW_USEDEFAULT,
           300,
           170,
           HWND_DESKTOP,
           NULL,
           hThisInstance,
           NULL
           );
   if(hwnd == NULL)
      {
      MessageBox(0, "Error", "Desborde del Heap",
                 MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
      return 0;
      }
    ShowWindow(hwnd, nFunsterStil);
    while(GetMessage(&messages, NULL, 0, 0))
    {
           TranslateMessage(&messages);
           DispatchMessage(&messages);
    }
    return messages.wParam;
}

LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
           case WM_CREATE:
           frInforma = CreateWindow(boton, szNombreVentana, WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                                   35, 15, 220, 120, hwnd, (HMENU)FR_INFORMACION, hInst, NULL);
           hBtCrear = CreateWindow(boton, "Crear", WS_CHILD|WS_VISIBLE|ES_CENTER,
                                   60, 40, 70, 30, hwnd, (HMENU)ID_CREAR, hInst, NULL);
           hBtRevisar = CreateWindow(boton, "Revisar", WS_CHILD|WS_VISIBLE|ES_CENTER,
                                   150, 40, 70, 30, hwnd, (HMENU)ID_REVISAR, hInst, NULL);
           hBtCerrar = CreateWindow(boton, "Cerrar", WS_CHILD|WS_VISIBLE|ES_CENTER,
                                   150, 90, 70, 30, hwnd, (HMENU)ID_CERRAR, hInst, NULL);
           hBtCerrar = CreateWindow(boton, "Crditos", WS_CHILD|WS_VISIBLE|ES_CENTER,
                                   60, 90, 70, 30, hwnd, (HMENU)ID_ACERCA, hInst,NULL);

           break;
           case WM_COMMAND:
              switch(LOWORD(wParam)){
                  case ID_CREAR:
                  /*Llamado a los diferentes dilogbox del programa*/
                     if(DialogBox(hInst, "Crear", hwnd, Crear) == -1)
                        MessageBox(hwnd, "Error al crear dilogo", "Error", MB_OK);
                  break;
                  case ID_REVISAR:
                     DialogBox(hInst, "Revisar", hwnd, Revisar);
                  break;
                  case ID_CERRAR:
                     SendMessage(hwnd, WM_DESTROY, wParam, lParam);
                  break;
                  case ID_ACERCA:
                     DialogBox(hInst, "Acerca", hwnd, Acerca);
                  break;

              }
           break;
           case WM_DESTROY:
           PostQuitMessage(0);
           break;
           default:
           return DefWindowProc(hwnd, message, wParam, lParam);
    }
    return 0;
}

BOOL CALLBACK Crear(HWND hdlg, UINT mensaje, WPARAM wparam, LPARAM lparam){

  switch(mensaje){
    case WM_INITDIALOG:
      suma = multas = cont = 0;
    break;
    case WM_COMMAND:
     switch(LOWORD(wparam)){
         case ID_INGRESO_CREAR:
              DialogBox(hInst, "Multar", hdlg, &Multar);
         break;
         case ID_ACTUALIZAR_CREAR:
              SetDlgItemInt(hdlg, ED_MULTAS_CREAR, multas, 0);
              SetDlgItemInt(hdlg, ED_VALOR_CREAR, suma, 0);
         break;
         case ID_GUARDAR_CREAR:
              AbrirGuardar(hdlg, TRUE);
         break;
         case ID_CERRAR_CREAR:
             EndDialog(hdlg, FALSE);
             return FALSE;
         break;
         case ID_NUEVO_CREAR:
              GetWindowText(GetDlgItem(hdlg, ED_PLACA_CREAR), nuevo[i].placa, 8);
              GetWindowText(GetDlgItem(hdlg, ED_ANIO_CREAR), nuevo[i].anio, 5);
              GetWindowText(GetDlgItem(hdlg, ED_DUENO_CREAR), nuevo[i].propietario, 40);
              GetWindowText(GetDlgItem(hdlg, ED_CEDULA_CREAR), nuevo[i].cedula, 11);
              GetWindowText(GetDlgItem(hdlg, ED_LICENCIA_CREAR), nuevo[i].licencia, 11);
              GetWindowText(GetDlgItem(hdlg, ED_MODELO_CREAR), nuevo[i].modelo, 12);
              GetWindowText(GetDlgItem(hdlg, ED_MARCA_CREAR), nuevo[i].marca, 11);
              GetWindowText(GetDlgItem(hdlg, ED_CAPACIDAD_CREAR), nuevo[i].capacidad, 2);
              GetWindowText(GetDlgItem(hdlg, ED_COLOR_CREAR), nuevo[i].color, 8);
              GetWindowText(GetDlgItem(hdlg, ED_MULTAS_CREAR), nuevo[i].multas, 3);
              GetWindowText(GetDlgItem(hdlg, ED_VALOR_CREAR), nuevo[i].valor, 6);
              i++;
              limpiar(hdlg);
              suma = 0;
              multas = 0;
         break;
         case WM_DESTROY:
             EndDialog(hdlg, FALSE);
             return FALSE;
         break;
      }
    break;
  }
  return FALSE;
}

BOOL CALLBACK Revisar(HWND hdlg, UINT mensaje, WPARAM wparam, LPARAM lparam){

  char multitas[6];
  char valores[7];
  switch(mensaje){
    case WM_INITDIALOG:
        suma = multas = cont = 0;
    break;
    case WM_COMMAND:
     switch(LOWORD(wparam)){
         case ID_ABRIR_REVISAR:
              AbrirGuardar(hdlg, FALSE);
         break;
         case ID_PLACA_REVISAR:
              DialogBox(hInst, "Placa", hdlg, &Placa);
         break;
         case ID_ACTUALIZAR_REVISAR:
              SetDlgItemInt(hdlg, ED_MULTAS_REVISAR, multas, 0);
              SetDlgItemInt(hdlg, ED_VALOR_REVISAR, suma, 0);
         break;
         case ID_PAGADO_REVISAR:
              SetWindowText(GetDlgItem(hdlg, ED_MULTAS_REVISAR), "0");
              SetWindowText(GetDlgItem(hdlg, ED_VALOR_REVISAR), "0");
              suma = 0;
              multas = 0;
         break;
         case ID_CERRAR_REVISAR:
              EndDialog(hdlg, FALSE);
              return FALSE;
         break;
         case ID_NUEVO_REVISAR:
             SendMessage(GetDlgItem(hdlg, ID_PAGADO_REVISAR), BM_SETCHECK, BST_UNCHECKED, lparam);
             limpiar(hdlg);
             suma = 0;
             multas = 0;
         break;
         case ID_GUARDAR_REVISAR:
              AbrirGuardarRevisar(hdlg, TRUE);
         break;
         case WM_DESTROY:
             EndDialog(hdlg, FALSE);
             return FALSE;
             break;
         }
  }
  return FALSE;
}

BOOL CALLBACK Multar(HWND hdlg, UINT mensaje, WPARAM wparam, LPARAM lparam){

  switch(mensaje){
    case WM_COMMAND:{
     switch(LOWORD(wparam)){
         case ID_ACEPTAR_INGRESAR:
         if(GetWindowText(GetDlgItem(hdlg, ED_MULTA_INGRESAR), cnt, 6) != 0){
           cont = atoi(cnt);
           if(cont != 0){
             multas++;
             suma = suma + cont;
             SetDlgItemText(hdlg, ED_MULTA_INGRESAR, "");
           }
           else SetDlgItemText(hdlg, ED_MULTA_INGRESAR, "");
         }
         break;
         case ID_CANCELAR_INGRESAR:
             EndDialog(hdlg, FALSE);
             return FALSE;
         break;
         case WM_DESTROY:{
             EndDialog(hdlg, FALSE);
             return FALSE;
             break;
         }
     }
    }
  }
  return FALSE;
}

BOOL CALLBACK Placa(HWND hdlg, UINT mensaje, WPARAM wparam, LPARAM lparam){

  switch(mensaje){
    case WM_INITDIALOG:
     i = j = m = cont = 0;
    break;
    case WM_COMMAND:{
     switch(LOWORD(wparam)){
         case ID_ACEPTAR_PLACA:
             GetWindowText(GetDlgItem(hdlg, ED_PLACA_PLACA), otraplaca.placa, 8);
             lstrcpy(placa_teclado, otraplaca.placa);
         break;
         case ID_CANCELAR_PLACA:
             if(otraplaca.placa == NULL)
               MessageBox (NULL, "Debe ingresar una placa" , "Informacin", 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);
             else EndDialog(hdlg, FALSE);
             return FALSE;
         break;
         case WM_DESTROY:{
             EndDialog(hdlg, FALSE);
             return FALSE;
             break;
         }
     }
    }
  }
  return FALSE;
}
BOOL CALLBACK Acerca(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam){

  switch(msg){
  case WM_DESTROY:
     EndDialog(hdlg, FALSE);
  break;
  case WM_COMMAND:
     switch(LOWORD(wParam)){
        case ID_ACEPTAR_ACERCA:
        case WM_DESTROY:
        EndDialog(hdlg, FALSE);
        break;
     }
  break;
  }
 return FALSE;
}

BOOL AbrirArchivo(HWND hEdit, LPSTR pszFileName)
{
   HANDLE hFile;/*handle de un archivo*/
   BOOL bSuccess = FALSE;
   PLACA masplaca;
   int cuantos = 0;
   hFile = CreateFile(pszFileName, GENERIC_READ, FILE_SHARE_READ, NULL,
                     OPEN_EXISTING, 0, 0);
   if(hFile != INVALID_HANDLE_VALUE)
   {

      DWORD dwFileSize;
      DWORD dwRead, dwWritten;
      dwFileSize = GetFileSize(hFile, NULL);
      if(dwFileSize != 0xFFFFFFFF)
      {
         LPSTR pszFileText;
         pszFileText = (LPSTR)GlobalAlloc(GPTR, 6000);
         if(pszFileText != NULL)
         {
            ver:
            if(ReadFile(hFile, masplaca.placa, 8, &dwRead, NULL))
            {

               if(strcmp(placa_teclado, masplaca.placa) != 0){
                  if(dwRead == 0)
                  {
                   MessageBox (NULL, "La placa ingresada no existe" , "Informacin", 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);
                  }
                  else{
                   SetFilePointer(hFile, -8, NULL, FILE_CURRENT);
                   ReadFile(hFile, aux[m].placa, 8, &dwRead, NULL);
                   ReadFile(hFile, aux[m].anio, 5, &dwRead, NULL);
                   ReadFile(hFile, aux[m].propietario, 40, &dwRead, NULL);
                   ReadFile(hFile, aux[m].cedula, 11, &dwRead, NULL);
                   ReadFile(hFile, aux[m].licencia, 11, &dwRead, NULL);
                   ReadFile(hFile, aux[m].modelo, 12, &dwRead, NULL);
                   ReadFile(hFile, aux[m].marca, 11, &dwRead, NULL);
                   ReadFile(hFile, aux[m].capacidad, 2, &dwRead, NULL);
                   ReadFile(hFile, aux[m].color, 8, &dwRead, NULL);
                   ReadFile(hFile, aux[m].multas, 3, &dwRead, NULL);
                   ReadFile(hFile, aux[m].valor, 6, &dwRead, NULL);
                   m++;
                   strcpy(masplaca.placa, "");
                   goto ver;
                  }
               }
               else{
                   ReadFile(hFile, masplaca.anio, 5, &dwRead, NULL);
                   ReadFile(hFile, masplaca.propietario, 40, &dwRead, NULL);
                   ReadFile(hFile, masplaca.cedula, 11, &dwRead, NULL);
                   ReadFile(hFile, masplaca.licencia, 11, &dwRead, NULL);
                   ReadFile(hFile, masplaca.modelo, 12, &dwRead, NULL);
                   ReadFile(hFile, masplaca.marca, 11, &dwRead, NULL);
                   ReadFile(hFile, masplaca.capacidad, 2, &dwRead, NULL);
                   ReadFile(hFile, masplaca.color, 8, &dwRead, NULL);
                   ReadFile(hFile, masplaca.multas, 3, &dwRead, NULL);
                   ReadFile(hFile, masplaca.valor, 6, &dwRead, NULL);
                   do{
                      ReadFile(hFile, aux[m].placa, 8, &dwRead, NULL);
                      ReadFile(hFile, aux[m].anio, 5, &dwRead, NULL);
                      ReadFile(hFile, aux[m].propietario, 40, &dwRead, NULL);
                      ReadFile(hFile, aux[m].cedula, 11, &dwRead, NULL);
                      ReadFile(hFile, aux[m].licencia, 11, &dwRead, NULL);
                      ReadFile(hFile, aux[m].modelo, 12, &dwRead, NULL);
                      ReadFile(hFile, aux[m].marca, 11, &dwRead, NULL);
                      ReadFile(hFile, aux[m].capacidad, 2, &dwRead, NULL);
                      ReadFile(hFile, aux[m].color, 8, &dwRead, NULL);
                      ReadFile(hFile, aux[m].multas, 3, &dwRead, NULL);
                      ReadFile(hFile, aux[m].valor, 6, &dwRead, NULL);
                      m++;
                   }while(dwRead != 0);
                   SetWindowText(GetDlgItem(hEdit, ED_PLACA_REVISAR), masplaca.placa);
                   SetWindowText(GetDlgItem(hEdit, ED_ANIO_REVISAR), masplaca.anio);
                   SetWindowText(GetDlgItem(hEdit, ED_DUENO_REVISAR), masplaca.propietario);
                   SetWindowText(GetDlgItem(hEdit, ED_CEDULA_REVISAR), masplaca.cedula);
                   SetWindowText(GetDlgItem(hEdit, ED_LICENCIA_REVISAR), masplaca.licencia);
                   SetWindowText(GetDlgItem(hEdit, ED_MODELO_REVISAR), masplaca.modelo);
                   SetWindowText(GetDlgItem(hEdit, ED_MARCA_REVISAR), masplaca.marca);
                   SetWindowText(GetDlgItem(hEdit, ED_CAPACIDAD_REVISAR), masplaca.capacidad);
                   SetWindowText(GetDlgItem(hEdit, ED_COLOR_REVISAR), masplaca.color);
                   SetWindowText(GetDlgItem(hEdit, ED_MULTAS_REVISAR), masplaca.multas);
                   SetWindowText(GetDlgItem(hEdit, ED_VALOR_REVISAR), masplaca.valor);
                   bSuccess = TRUE;
               }
            }
            GlobalFree(pszFileText);
         }
      }
      CloseHandle(hFile);
   }
   return bSuccess;
}

BOOL GuardarArchivo(HWND hEdit, LPSTR pszFileName)
{
   HANDLE hFile;
   BOOL bSuccess = FALSE;
   PLACA estaplaca;
   hFile = CreateFile(pszFileName, GENERIC_WRITE, 0, 0,
                     CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
   if(hFile != INVALID_HANDLE_VALUE)
   {
         LPSTR pszText;
         pszText = (LPSTR)GlobalAlloc(GPTR, 6000);
         if(pszText != NULL)
         {
            if(*pszFileName != '['){
               DWORD dwWritten;
               for(int i = 0; i < 50; i++){
                   WriteFile(hFile, nuevo[i].placa, 8, &dwWritten, NULL);
                   WriteFile(hFile, nuevo[i].anio, 5, &dwWritten, NULL);
                   WriteFile(hFile, nuevo[i].propietario, 40, &dwWritten, NULL);
                   WriteFile(hFile, nuevo[i].cedula, 11, &dwWritten, NULL);
                   WriteFile(hFile, nuevo[i].licencia, 11, &dwWritten, NULL);
                   WriteFile(hFile, nuevo[i].modelo, 12, &dwWritten, NULL);
                   WriteFile(hFile, nuevo[i].marca, 11, &dwWritten, NULL);
                   WriteFile(hFile, nuevo[i].capacidad, 2, &dwWritten, NULL);
                   WriteFile(hFile, nuevo[i].color, 8, &dwWritten, NULL);
                   WriteFile(hFile, nuevo[i].multas, 3, &dwWritten, NULL);
                   if(WriteFile(hFile, nuevo[i].valor, 6, &dwWritten, NULL))
                      bSuccess = TRUE;
               }
            }
            GlobalFree(pszText);
         }
         CloseHandle(hFile);
   }
   return bSuccess;
}

BOOL AbrirGuardar(HWND hwnd, BOOL bSave)
{
   OPENFILENAME ofn;
   char szFileName[MAX_PATH];

   ZeroMemory(&ofn, sizeof(ofn));
   szFileName[0] = 0;

   ofn.lStructSize = sizeof(ofn);
   ofn.hwndOwner = hwnd;
   /*Archivos a filtrar*/
   ofn.lpstrFilter = "Archivos de placas (*.cfv)\0*.cfv\0";
   ofn.lpstrFile = szFileName;
   ofn.nMaxFile = MAX_PATH;
   /*Extensin del archivo a filtrar, pueden usar sus iniciales tambin*/
   ofn.lpstrDefExt = "cfv";
   if(bSave)
   {
      ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY |
         OFN_OVERWRITEPROMPT;
         
      if(GetSaveFileName(&ofn))//Esta funcin es la que crea el Dilogo GuardarComo
      {
             if(!GuardarArchivo(hwnd, szFileName))
             {
                MessageBox(hwnd, "Error en la escritura", "Error",
                            MB_OK | MB_ICONEXCLAMATION);
                 return FALSE;
             }
      }
   }
   else
   {
      ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
      if(GetOpenFileName(&ofn))//Esta funcin crea el dilogo Abrir
      {
         if(!AbrirArchivo(hwnd, szFileName))
         {
            MessageBox(hwnd, "Error en la lectura", "Error",
               MB_OK | MB_ICONEXCLAMATION);
            return FALSE;
         }
      }
   }
   return TRUE;
}

BOOL GuardarArchivoRevisar(HWND hEdit, LPSTR pszFileName)
{
   HANDLE hFile;
   BOOL bSuccess = FALSE;
   PLACA estaplaca;
   hFile = CreateFile(pszFileName, GENERIC_WRITE, 0, 0,
                     CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
   if(hFile != INVALID_HANDLE_VALUE)
   {
         LPSTR pszText;
         pszText = (LPSTR)GlobalAlloc(GPTR, 6000);
         if(pszText != NULL)
         {
            if(*pszFileName != '['){
               DWORD dwWritten;
               for(int i = 0; i < 50; i++){
                   WriteFile(hFile, aux[i].placa, 8, &dwWritten, NULL);
                   WriteFile(hFile, aux[i].anio, 5, &dwWritten, NULL);
                   WriteFile(hFile, aux[i].propietario, 40, &dwWritten, NULL);
                   WriteFile(hFile, aux[i].cedula, 11, &dwWritten, NULL);
                   WriteFile(hFile, aux[i].licencia, 11, &dwWritten, NULL);
                   WriteFile(hFile, aux[i].modelo, 12, &dwWritten, NULL);
                   WriteFile(hFile, aux[i].marca, 11, &dwWritten, NULL);
                   WriteFile(hFile, aux[i].capacidad, 2, &dwWritten, NULL);
                   WriteFile(hFile, aux[i].color, 8, &dwWritten, NULL);
                   WriteFile(hFile, aux[i].multas, 3, &dwWritten, NULL);
                   if(WriteFile(hFile, aux[i].valor, 6, &dwWritten, NULL))
                      bSuccess = TRUE;
               }
            }
            GlobalFree(pszText);
         }
         CloseHandle(hFile);
   }
   return bSuccess;
}

BOOL AbrirGuardarRevisar(HWND hwnd, BOOL bSave)
{
   OPENFILENAME ofn;
   char szFileName[MAX_PATH];

   ZeroMemory(&ofn, sizeof(ofn));
   szFileName[0] = 0;

   ofn.lStructSize = sizeof(ofn);
   ofn.hwndOwner = hwnd;
   ofn.lpstrFilter = "Archivos de placas (*.cfv)\0*.cfv\0";
   ofn.lpstrFile = szFileName;
   ofn.nMaxFile = MAX_PATH;
   ofn.lpstrDefExt = "cfv";
   if(bSave)
   {
      ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY |
         OFN_OVERWRITEPROMPT;
         
      if(GetSaveFileName(&ofn))
      {
         if(!GuardarArchivoRevisar(hwnd, szFileName))
             {
                MessageBox(hwnd, "Error en la escritura", "Error",
                            MB_OK | MB_ICONEXCLAMATION);
                 return FALSE;
             }
      }

   }
   return TRUE;
}



